// #name = ET-FOV
// #version = 1.0
// #date = 2002-06-04
// #author = Anakha
// #credit = Kaiten Commander
// #email = Anakha@eurotroops.nu
// #web = http://www.eurotroops.nu
// #description = Change your FOV while ingame via a small GUI.
// #status = Beta

// -------------------------------------------------------------------

package FOVChanger
{
function FOVChanGUI::onWake( %this )
{
	FOVSlider.setValue( $pref::Player::defaultFov * 1000 );
}

// -------------------------------------------------------------------

function updateFOVValue()
{
	$FoV = mFloor(FOVSlider.getValue()/1000);
	$pref::Player::defaultFov = $FoV;
	FOVSlidertext.setValue("FoV - " @ $FoV);
}

// -------------------------------------------------------------------

function FOVChanGUI::onSleep( %this )
{
	%this.saveSettings();
}	

// -------------------------------------------------------------------

function FOVChanGUI::saveSettings( %this )
{
	$pref::Player::defaultFov = $FoV;
	setFov( $pref::player::defaultFov );
}		

// -------------------------------------------------------------------

function DispatchLaunchMode()
{
	FOVChanGUICreate();

	parent::DispatchLaunchMode();
}

// -------------------------------------------------------------------

function FOVChanGUIDestroy()
{
	if ($FOVChanGUI !$= "")
	{
		Canvas.popDialog(FOVChanGUI);
		FOVChanGUI.delete();
		$FOVChanGUI = "";
	}
}

// -------------------------------------------------------------------

function FOVChanGUIToggle(%val)
{
    if (%val)
    {
        if($FOVChanToggle)
        {
		$FOVChanToggle = false;
		Canvas.PushDialog(FOVChanGUI);		
         }
         else
         {
		$FOVChanToggle = true;
		Canvas.popDialog(FOVChanGUI);
	 }
     }
}

// -------------------------------------------------------------------
	
function OptionsDlg::onWake( %this )
{
	if(!$FOVChanBind) {
        	$RemapName[$RemapCount]="ET-FOV";
        	$RemapCmd[$RemapCount]="FOVChanGUIToggle";
        	$RemapCount++;
         	$FOVChanBind = true;
   	}
   	parent::onWake( %this );
}

// -------------------------------------------------------------------

function FOVChanGUICreate()
{
	FOVChanGUIDestroy();

	new GuiControl(FOVChanGUI) {
		profile = "DlgBackProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
	
		new ShellPaneCtrl(FOVChanpane) {
			profile = "ShellPaneProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "260 120";
			minExtent = "48 92";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "ET-FOV";
			maxLength = "255";
			noTitleBar = "0";

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "55 40";
				extent = "79 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Desired FOV: From 60 to 120";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellSliderCtrl(FOVSlider) {
				profile = "ShellSliderProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "40 60";
				extent = "170 24";
				minExtent = "12 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "value";
				altCommand = "updateFOVValue();";
				helpTag = "0";
				range = "60000 120000";
				ticks = "10";
				value = "90000";
				usePlusMinus = "1";
			};
			new GuiTextCtrl(FOVSliderText) {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "105 82";
				extent = "109 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};			
		};
	};
}

// -------------------------------------------------------------------

};
$FOVChanToggle = true;
activatePackage(FOVChanger);					